<script lang="ts">
import { MetaInfo } from 'vue-meta/types/vue-meta';
import {
  Hero,
  Cities,
  ConductBanner,
  WorldTourForm,
} from '~/components/events/world-tour/index.vue';
import { NextStep, Faq as FAQ } from '~/components/common/index.vue';

import { getPageMetadata } from '~/common/meta';
import { CONTENT_TYPES } from '~/common/content-types';
import { getClient } from '~/plugins/contentful.js';
import {
  worldTourLandingHelper,
  WorldTourLandingData,
} from '~/services/events/world-tour-landing.service';

export default {
  name: 'WorldTour',
  components: {
    Hero,
    Cities,
    WorldTourForm,
    ConductBanner,
    NextStep,
    FAQ,
  },
  nuxtI18n: false,
  async asyncData() {
    const content: WorldTourLandingData = await getClient()
      .getEntries({
        content_type: CONTENT_TYPES.PAGE,
        include: 10,
        'sys.id': '1X2imnKJJbJT3akHkUSi7H',
      })
      .then((query: any) => {
        const entryFields = query.items[0]?.fields;

        return worldTourLandingHelper(entryFields);
      })
      .catch(console.error);
    return { content };
  },
  head(): MetaInfo {
    return {
      ...getPageMetadata((this as any).content.metadata, this.$route.path),
    };
  },
};
</script>
<template>
  <div>
    <Hero v-bind="content.hero" />
    <Cities :regions="content.regions" />
    <WorldTourForm v-if="content.form.formId" v-bind="content.form" />
    <FAQ :data="content.faq" active-header="DevSecOps World Tour" />
    <ConductBanner v-bind="content.banner" />
    <SlpContainer variant="gradient">
      <NextStep :variant="content.nextSteps" />
    </SlpContainer>
  </div>
</template>
